//----------------------------------------
// All time units are in microseconds (us)
//----------------------------------------

#define TCKH 2         	//Clock pulse width (2us)
			// 1 Clock cycle -> 4us
			// 1 command (32 clock cycles) -> 128us

// Chip erase duration for various voltages (us);
#define TERASE_32 18000
#define TERASE_36 14000
#define TERASE_40 12000
#define TERASE_50 8000

#define TERASE TERASE_32

// Programming duration for various voltages (us)
#define TPROG_32 9000
#define TPROG_36 7000
#define TPROG_40 6000
#define TPROG_50 4000

#define TPROG TPROG_32

// More than enough time for fuse programming
#define TFUSE 20000	


#define NTOUT (TPROG/64/TCKH) 		//timeout for polling (#commands)
#define NTERASE (TERASE/64/TCKH)	//timeout for erase   (#commands)


void udelay(int n);
void delay_calibrate();
