#include <stdlib.h>
#include "forms.h"
#include "fusesmega.h"
#include "common.h"
#include "bbang.h"
#include "delay.h"

extern FD_fusesmega *fd_fusesmega;

unsigned char fuses,fusesh,fusesx,lockb,cali;

void update_fuses()
{
    fl_set_button(fd_fusesmega->fus7,(fuses&0x80)?1:0);
    fl_set_button(fd_fusesmega->fus6,(fuses&0x40)?1:0);
    fl_set_button(fd_fusesmega->fus5,(fuses&0x20)?1:0);
    fl_set_button(fd_fusesmega->fus4,(fuses&0x10)?1:0);
    fl_set_button(fd_fusesmega->fus3,(fuses&0x08)?1:0);
    fl_set_button(fd_fusesmega->fus2,(fuses&0x04)?1:0);
    fl_set_button(fd_fusesmega->fus1,(fuses&0x02)?1:0);
    fl_set_button(fd_fusesmega->fus0,(fuses&0x01)?1:0);

    fl_set_button(fd_fusesmega->fush7,(fusesh&0x80)?1:0);
    fl_set_button(fd_fusesmega->fush6,(fusesh&0x40)?1:0);
    fl_set_button(fd_fusesmega->fush5,(fusesh&0x20)?1:0);
    fl_set_button(fd_fusesmega->fush4,(fusesh&0x10)?1:0);
    fl_set_button(fd_fusesmega->fush3,(fusesh&0x08)?1:0);
    fl_set_button(fd_fusesmega->fush2,(fusesh&0x04)?1:0);
    fl_set_button(fd_fusesmega->fush1,(fusesh&0x02)?1:0);
    fl_set_button(fd_fusesmega->fush0,(fusesh&0x01)?1:0);

    fl_set_button(fd_fusesmega->fusx7,(fusesx&0x80)?1:0);
    fl_set_button(fd_fusesmega->fusx6,(fusesx&0x40)?1:0);
    fl_set_button(fd_fusesmega->fusx5,(fusesx&0x20)?1:0);
    fl_set_button(fd_fusesmega->fusx4,(fusesx&0x10)?1:0);
    fl_set_button(fd_fusesmega->fusx3,(fusesx&0x08)?1:0);
    fl_set_button(fd_fusesmega->fusx2,(fusesx&0x04)?1:0);
    fl_set_button(fd_fusesmega->fusx1,(fusesx&0x02)?1:0);
    fl_set_button(fd_fusesmega->fusx0,(fusesx&0x01)?1:0);

    fl_set_button(fd_fusesmega->loc5,(lockb&0x20)?1:0);
    fl_set_button(fd_fusesmega->loc4,(lockb&0x10)?1:0);
    fl_set_button(fd_fusesmega->loc3,(lockb&0x08)?1:0);
    fl_set_button(fd_fusesmega->loc2,(lockb&0x04)?1:0);
    fl_set_button(fd_fusesmega->loc1,(lockb&0x02)?1:0);
    fl_set_button(fd_fusesmega->loc0,(lockb&0x01)?1:0);

}

/*** callbacks and freeobj handles for form fusesmega ***/
void locb(FL_OBJECT *ob, long data)
{
  if (fl_get_button(ob)) lockb |=1<<data;
  else lockb &=~(1<<data);
}

void rdfuses(FL_OBJECT *ob, long data)
{
  if (SPI_sync()) return;
  fuses=cmd_read_fuses();
  set_Vcc_L();
  update_fuses();
}

void wrfuses(FL_OBJECT *ob, long data)
{
  if (fl_show_question("FUSE bits WRITE.\nDo you want to continue?", 0)==0) return;
  message("----- FUSE bits WRITE started",4);
  if (SPI_sync()) return;
  cmd_write_fuses(fuses);
  usleep(TFUSE);
  set_Vcc_L();
  message("----- FUSE bits WRITE OK",4);
}

void rdlockb(FL_OBJECT *ob, long data)
{
  if (SPI_sync()) return;
  lockb=cmd_read_lock()&0x3f;
  set_Vcc_L();
  update_fuses();
}

void wrlockb(FL_OBJECT *ob, long data)
{
  if (fl_show_question("LOCK bits WRITE.\nDo you want to continue?", 0)==0) return;
  message("----- LOCK bits WRITE started",4);
  if (SPI_sync()) return;
  cmd_write_lock(lockb);
  usleep(TFUSE);
  set_Vcc_L();
  message("----- LOCK bits WRITE OK",4);
}

void rdfusesh(FL_OBJECT *ob, long data)
{
  if (SPI_sync()) return;
  fusesh=cmd_read_fusesH();
  set_Vcc_L();
  update_fuses();
}
void wrfusesh(FL_OBJECT *ob, long data)
{
  if (fl_show_question("FUSE HIGH bits WRITE.\nDo you want to continue?", 0)==0) return;
  message("----- FUSE HIGH bits WRITE started",4);
  if (SPI_sync()) return;
  cmd_write_fusesH(fusesh);
  usleep(TFUSE);
  set_Vcc_L();
  message("----- FUSE HIGH bits WRITE OK",4);

}


void rdfusesex(FL_OBJECT *ob, long data)
{
  if (SPI_sync()) return;
  fusesx=cmd_read_fusesEx();
  set_Vcc_L();
  update_fuses();
}
void wrfusesex(FL_OBJECT *ob, long data)
{
  if (fl_show_question("FUSE Extended bits WRITE.\nDo you want to continue?", 0)==0) return;
  message("----- FUSE Extended bits WRITE started",4);
  if (SPI_sync()) return;
  cmd_write_fusesEx(fusesx);
  usleep(TFUSE);
  set_Vcc_L();
  message("----- FUSE Extended bits WRITE OK",4);

}

void rdcal(FL_OBJECT *ob, long data)
{
  unsigned char buf[80];
  if (SPI_sync()) return;
  cali=cmd_read_cal(data);
  set_Vcc_L();
  sprintf(buf,"%d:%d",data,cali);
  fl_set_object_label(fd_fusesmega->cali,buf);
}

void fusb(FL_OBJECT *ob, long data)
{
  if (fl_get_button(ob)) fuses |=1<<data;
  else fuses &=~(1<<data);
}

void fushb(FL_OBJECT *ob, long data)
{
  if (fl_get_button(ob)) fusesh |=1<<data;
  else fusesh &=~(1<<data);
}

void fusxb(FL_OBJECT *ob, long data)
{
  if (fl_get_button(ob)) fusesx |=1<<data;
  else fusesx &=~(1<<data);
}


extern int fusesmega_done;
void fusexit(FL_OBJECT *ob, long data)
{
  fusesmega_done=1;
}

