#include <stdio.h>
#include "id.h"

// Chip specific definitions:
// int id;		-> The 3 signature bytes of the chip
// int flash_size;	-> The size of the flash memory (bytes)
// int eeprom_size;	-> The size of the EEPROM memory (bytes)
// int page_size;	-> The size of a Flash page (words)
//			   0 means no pages at all (older chips)
// char p0;		-> The value read during flash programming while busy
// char p1;		-> The value read during EEPROM erase while busy
// char p2;		-> The value read during EEPROM programming while busy
//			   0x1 means to use POLL/RDY command
// char fuses; 		-> Fuse mask bits:
//			   0:fuses, 1:fusesh, 2:fusesEX, 3:lock
// char *name;		-> A name for the chip

const chip_id idt[]={
    0xfffffe,    0,   0, 0,0xff,0xff,0xff,0,"NONE",
    // Old small chips
    0x1e9101, 2048, 128, 0,0x7f,0x80,0x7f,0,"AT90S2313",
    0x1e9001, 1024,  64, 0,0xff,0x00,0xff,0,"AT90S1200",
    // Old Mega chips
    0x1e9307, 8192, 512,32,0xff,0xff,0xff,0x0b,"ATMEGA8",
    0x1e9403,16384, 512,64,0xff,0xff,0xff,0x0b,"ATMEGA16",
    0x1e9502,32768,1024,64,0xff,0xff,0xff,0x0b,"ATMEGA32",
    // New small chips
    0x1e910A, 2048, 128,16,0x01,0x01,0x01,0x0f,"ATtiny2313",
    // New mega chips
    0x1e9205, 4096, 256,32,0x01,0x01,0x01,0x0f,"ATMega48",
    0x1e930a, 8192, 512,32,0x01,0x01,0x01,0x0f,"ATMega88",
    0x1e9406,16384, 512,64,0x01,0x01,0x01,0x0f,"ATMega168",
    // Tiny24/44/84
    0x1e910B, 2048, 128,16,0x01,0x01,0x01,0x0f,"ATtiny24",
    0x1e9107, 4096, 256,32,0x01,0x01,0x01,0x0f,"ATtiny44",
    0x1e910C, 8192, 512,32,0x01,0x01,0x01,0x0f,"ATtiny84",
    
    // Table terminator
    0,0,0,0,0,0,0,0,NULL
};

