#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "common.h"
#include "ioport.h"

#ifndef linux
#include <sys/perm.h>
#endif

#define MCR (iobase+4)
#define MSR (iobase+6)
#define LCR (iobase+3)

int iobase;

extern char *prog_dev;
//int mcr;

void set_Vcc_H() // Or RESET low
{
        // Set a break status
        //if (ioctl(serial_fd,TIOCSBRK,0)) message("TIOCSBRK failed",1);
        outb(inb(LCR)|0x40,LCR);
}

void set_Vcc_L() // Or RESET High
{
        // Clear the break status
        //if (ioctl(serial_fd,TIOCCBRK,0)) message("TIOCCBRK failed",1);
        outb(inb(LCR)&(~0x40),LCR);
}

void set_SCK_H()
{
        // Set DTR=1
        //mcr|=TIOCM_DTR;
        //if (ioctl(serial_fd,TIOCMSET,&mcr)) message("TIOCMSET failed",1);
        outb(inb(MCR)|1,MCR);
}
void set_SCK_L()
{
        // Set DTR=0
        //mcr&=~TIOCM_DTR;
        //if (ioctl(serial_fd,TIOCMSET,&mcr)) message("TIOCMSET failed",1);
        outb(inb(MCR)&(~1),MCR);
}
void set_MOSI_H()
{
        // Set RTS=1
        //mcr|=TIOCM_RTS;
        //if(ioctl(serial_fd,TIOCMSET,&mcr))message("TIOCMSET failed",1);
        outb(inb(MCR)|2,MCR);
}
void set_MOSI_L()
{
        // Set RTS=0
        //mcr&=~TIOCM_RTS;
        //if (ioctl(serial_fd,TIOCMSET,&mcr))message("TIOCMSET failed",1);
        outb(inb(MCR)&(~2),MCR);
}

int get_MISO()
{
//        int res=0;
//        if (ioctl(serial_fd,TIOCMGET,&res))message("TIOCMGET failed",1);
//        res=~res;
//        return res&TIOCM_CTS;
        return (~inb(MSR))&0x10;
}


void init_io()
{
    int i;
    char buf[256];


    sprintf(buf,"----- Opening Serial Port (%s)...",prog_dev);
    message(buf,4);

    iobase=0;
#ifdef linux
    if (iopl(3)) {message("ERROR: root privileges required",1); return;}
    if (strstr(prog_dev,"ttyS0")) iobase=0x3f8;
    if (strstr(prog_dev,"ttyS1")) iobase=0x2f8;
#else
    if (iopl(3)) {message("ERROR: Execute ioperm -i",1); return;}
    if (strstr(prog_dev,"COM1")) iobase=0x3f8;
    if (strstr(prog_dev,"COM2")) iobase=0x2f8;
#endif
    if (!iobase) message("ERROR: unknown serial device",1);
    else {
        sprintf(buf,"----- IO Base: 0x%03X",iobase);
        message(buf,4);
    }

    set_Vcc_L();
    set_SCK_L();
    set_MOSI_L();
    //message("----- Serial port OK",4);
}


