#include <stdlib.h>
#ifdef __linux
#include <asm/termios.h>
#else
#include <termios.h>
#endif
#include <fcntl.h>
#include <stdio.h>
#include "common.h"

//#define SERIAL_DEV "/dev/serial0"

extern char *prog_dev;
int serial_fd=0;
int mcr;

void set_Vcc_H() // Or RESET low
{
        // Set a break status
        if (ioctl(serial_fd,TIOCSBRK,0)) message("TIOCSBRK failed",1);
}

void set_Vcc_L() // Or RESET High
{
        // Clear the break status
        if (ioctl(serial_fd,TIOCCBRK,0)) message("TIOCCBRK failed",1);
}

void set_SCK_H()
{
        // Set DTR=1
        mcr|=TIOCM_DTR;
        if (ioctl(serial_fd,TIOCMSET,&mcr)) message("TIOCMSET failed",1);
}
void set_SCK_L()
{
        // Set DTR=0
        mcr&=~TIOCM_DTR;
        if (ioctl(serial_fd,TIOCMSET,&mcr)) message("TIOCMSET failed",1);
}
void set_MOSI_H()
{
        // Set RTS=1
        mcr|=TIOCM_RTS;
        if(ioctl(serial_fd,TIOCMSET,&mcr))message("TIOCMSET failed",1);
}
void set_MOSI_L()
{
        // Set RTS=0
        mcr&=~TIOCM_RTS;
        if (ioctl(serial_fd,TIOCMSET,&mcr))message("TIOCMSET failed",1);
}

int get_MISO()
{
        int res=0;
        if (ioctl(serial_fd,TIOCMGET,&res))message("TIOCMGET failed",1);
        res=~res;
        return res&TIOCM_CTS;
}


void init_io()
{
    char buf[256];

    sprintf(buf,"----- Opening Serial Port (%s)...",prog_dev);
    message(buf,4);
    if ((serial_fd=open(prog_dev,O_RDWR))==-1) {
        sprintf(buf,"Error opening %s device",prog_dev);
        message(buf,1); return;
    }
    if(ioctl(serial_fd,TIOCMGET,&mcr)) {message("TIOCMGET failed",1); return;}
    set_Vcc_L();
    set_SCK_L();
    set_MOSI_L();
    message("----- Serial port OK",4);
}


