	.section .init
        /* Jump table for Reset & Interrupts */
	rjmp __reset

        /**** Interrupt vectors Not Yet Implemented */
        rjmp __noirq /* ext_int0   */
        rjmp __noirq /* ext_int1   */
	rjmp __noirq /* tim2_comp  */
	rjmp __noirq /* tim2_ovf   */
        rjmp __noirq /* tim1_capt  */
        rjmp __noirq /* tim1_compa */
	rjmp __noirq /* tim1_compb */
        rjmp __noirq /* tim1_ovf   */
        rjmp __noirq /* tim0_ovf   */
	rjmp __noirq /* spi_stc    */
        rjmp __noirq /* usart_rxc  */
        rjmp __noirq /* usart_udre */
        rjmp __noirq /* usart_txc  */
	rjmp __noirq /* adc        */
	rjmp __noirq /* ee_rdy     */
        rjmp __noirq /* ana_comp   */
	rjmp __noirq /* twsi       */
	rjmp __noirq /* spm_rdy    */

	/*********************************************/

__reset:
	clr r1
	/* Z=_etext */
        ldi r30,lo8(_etext)
        ldi r31,hi8(_etext)
        /* Y=.data */
        ldi r28,lo8(.data)
        ldi r29,hi8(.data)
	/* temporary registers for CPC */
	ldi r16,hi8(_edata)
	ldi r17,hi8(_end)

	/* Copying .data initial values from Flash to RAM*/
__data_init_buc:
        cpi r28,lo8(_edata)
	cpc r29,r16
	breq __zero_bss
        lpm r0,Z+
        st Y+,r0
        rjmp __data_init_buc

	/* Zeroing .bss section */
__zero_bss:
	cpi r28,lo8(_end)
	cpc r29,r17
	breq __main_jmp
	st Y+,r1
	rjmp __zero_bss

        /* Jump to main. (Stack is initialized there) */
__main_jmp:
        rjmp main

	/* Dummy interrupt routine */
__noirq:
	reti

