#define	TWAR	(*(volatile unsigned char *)0x22)
#define	TWDR	(*(volatile unsigned char *)0x23)
#define	ADC	(*(volatile unsigned short *)0x24)
#define	ADCSRA	(*(volatile unsigned char *)0x26)
#define	ADMUX	(*(volatile unsigned char *)0x27)

#define ACSR   	(*(volatile unsigned char *)0x28)

#define UBRR   	(*(volatile unsigned char *)0x29)
#define UCR    	(*(volatile unsigned char *)0x2a)
#define USR    	(*(volatile unsigned char *)0x2b)
#define UDR    	(*(volatile unsigned char *)0x2c)

#define	SPCR	(*(volatile unsigned char *)0x2d)
#define	SPSR	(*(volatile unsigned char *)0x2e)
#define	SPDR	(*(volatile unsigned char *)0x2f)

#define PIND   	(*(volatile unsigned char *)0x30)
#define DDRD   	(*(volatile unsigned char *)0x31)
#define PORTD  	(*(volatile unsigned char *)0x32)

#define PINC   	(*(volatile unsigned char *)0x33)
#define DDRC   	(*(volatile unsigned char *)0x34)
#define PORTC  	(*(volatile unsigned char *)0x35)

#define PINB   	(*(volatile unsigned char *)0x36)
#define DDRB   	(*(volatile unsigned char *)0x37)
#define PORTB  	(*(volatile unsigned char *)0x38)

#define EECR   	(*(volatile unsigned char *)0x3c)
#define EEDR   	(*(volatile unsigned char *)0x3d)
#define EEAR   	(*(volatile unsigned short *)0x3e)
#define	EEARL	(*(volatile unsigned char *)0x3e)
#define	EEARH	(*(volatile unsigned char *)0x3f)

#define	UBRRH	(*(volatile unsigned char *)0x40)
#define	UCSRC	(*(volatile unsigned char *)0x40)

#define WDTCR  	(*(volatile unsigned char *)0x41)

#define	ASSR	(*(volatile unsigned char *)0x42)
#define	OCR2	(*(volatile unsigned char *)0x43)
#define	TCNT2	(*(volatile unsigned char *)0x44)
#define	TCCR2	(*(volatile unsignedchar *)0x45)

#define ICR1   	(*(volatile unsigned short *)0x46)
#define ICR1L  	(*(volatile unsigned char *)0x46)
#define ICR1H  	(*(volatile unsigned char *)0x47)

#define	OCR1B	(*(volatile unsigned short *)0x48)
#define	OCR1BL	(*(volatile unsigned char *)0x48)
#define	OCR1BH	(*(volatile unsigned char *)0x49)

#define OCR1A  	(*(volatile unsigned short *)0x4a)
#define OCR1AL 	(*(volatile unsigned char *)0x4a)
#define OCR1AH 	(*(volatile unsigned char *)0x4b)

#define TCNT1  	(*(volatile unsigned short *)0x4c)
#define TCNT1L 	(*(volatile unsigned char *)0x4c)
#define TCNT1H 	(*(volatile unsigned char *)0x4d)

#define TCCR1B 	(*(volatile unsigned char *)0x4e)
#define TCCR1A 	(*(volatile unsigned char *)0x4f)

#define	SFIOR	(*(volatile unsigned char *)0x50)
#define	OSCCAL	(*(volatile unsigned char *)0x51)

#define TCNT0  	(*(volatile unsigned char *)0x52)
#define TCCR0  	(*(volatile unsigned char *)0x53)

#define	MCUCSR	(*(volatile unsigned char *)0x54)
#define MCUCR  	(*(volatile unsigned char *)0x55)

#define	TWCR	(*(volatile unsigned char *)0x56)
#define	SPMCR	(*(volatile unsigned char *)0x57)

#define TIFR   	(*(volatile unsigned char *)0x58)
#define TIMSK  	(*(volatile unsigned char *)0x59)

#define GIFR   	(*(volatile unsigned char *)0x5a)
#define GICR   	(*(volatile unsigned char *)0x5b)

#define	SP	(*(volatile unsigned short *)0x5d)
#define SPL    	(*(volatile unsigned char *)0x5d)
#define	SPH	(*(volatile unsigned char *)0x5e)

#define SREG   	(*(volatile unsigned char *)0x5f)


/* CBI and SBI require constant port and constant bit */

#define CBI(port, bit)                                \
        __asm__ __volatile__ (                          \
                "cbi %0,%1"                             \
                : /* no outputs */                      \
                : "I" ((const unsigned char)((port)-0x20)), \
                  "I" ((const unsigned char)(bit))                  \
        )

#define SBI(port, bit)                                \
        __asm__ __volatile__ (                          \
                "sbi %0,%1"                             \
                : /* no outputs */                      \
                : "I" ((const unsigned char)((port)-0x20)), \
                  "I" ((const unsigned char)(bit))                  \
        )
